## ?zip=crc

=== jsplugins/Makefile ===
PACKAGE_CONTENTS = jsplugin.h \
		doc/HOWTO.html \
		examples/triggerreceiver.c \
		examples/triggerreceiver.html \
		examples/videoplayer.c \
		examples/videoplayer.html \
		examples/jsplugin_videoplayer.dsp \
		examples/Makefile \
		examples/README.txt

PACKAGE_VERSION = $(shell cut -c2- CVS/Tag)
PACKAGE_DATE = $(shell date +%Y-%m-%d--%H-%M)
PACKAGE_NAME = opera_jsplugins_sdk_$(PACKAGE_VERSION)

package:
	mkdir -p .pack/$(PACKAGE_NAME)
	tar cf .pack/tmpmiff.tar $(PACKAGE_CONTENTS)
	cd .pack/$(PACKAGE_NAME) ; tar xf ../tmpmiff.tar ; rm ../tmpmiff.tar
	cd .pack ; tar cfz ../$(PACKAGE_NAME).tgz $(PACKAGE_NAME)

clean:
	rm -Rf .pack

=== libgogi/Makefile ===
# -*- Mode: Makefile; tab-width: 4 -*-
# vim: syntax=make ts=4

#choose your backend:
#BACKEND=GTK
#BACKEND=SDL

DEBUG ?= YES

USE_FREETYPE=YES

CPPFLAGS+=-Wall

LIBSOURCES=mde.cpp mde_blit.cpp mde_mouse.cpp mde_view.cpp mde_font.cpp
LIBOBJECTS=$(LIBSOURCES:.cpp=.o)

all: libgogi.a test

libgogi.a: $(LIBOBJECTS)
	ar crs $@ $^

TESTSOURCES=test/mde_test.cpp

ifeq ($(BACKEND),)
$(error "you need to choose what backend to use")
endif

ifeq ($(BACKEND), GTK)
TESTLIBS=`pkg-config gtk+-2.0 --libs`
TESTSOURCES+=test/mde_test_gtk.cpp
CPPFLAGS+=$(shell pkg-config gtk+-2.0 --cflags)
TESTTARGET=test/mde_test_gtk
endif

ifeq ($(BACKEND), SDL)
TESTLIBS=`sdl-config --libs`
TESTSOURCES+=test/mde_test_sdl.cpp
CPPFLAGS+=$(shell sdl-config --cflags)
TESTTARGET=test/mde_test_sdl
endif

ifeq ($(USE_FREETYPE), YES)
CPPFLAGS+=$(shell freetype-config --cflags)
TESTLIBS+=$(shell freetype-config --libs)
endif

TESTOBJECTS=$(TESTSOURCES:.cpp=.o)

test: $(TESTTARGET)

$(TESTTARGET): $(TESTOBJECTS) $(LIBOBJECTS)
	g++ $(LDFLAGS) -o $@ $(TESTLIBS) $^

clean:
	rm -f libgogi.a $(LIBOBJECTS) $(TESTOBJECTS)

ifeq ($(DEBUG), YES)
CPPFLAGS+=-g
LDFLAGS+=-g
else
CPPFLAGS+=-Os
endif

=== jsplugins/examples/Makefile ===
SOURCES = videoplayer.c triggerreceiver.c slashproc.c
TARGETS=$(SOURCES:.c=.so)

CC=gcc
CFLAGS=

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

%.so: %.c
	$(CC) $(CFLAGS) -I.. -shared -fPIC $< -o $@

=== memory/documentation/Makefile ===
# Makefile for documentation creation

pdf:
	doxygen Doxyfile.pdf
	cd latex; make

=== memory/selftest/Makefile ===
# Makefile to create and run all the configuration tests

all:	common
	@rm -f cfg[0-9] cfg[0-9][0-9]
	@rm -f cfg[0-9].cpp cfg[0-9][0-9].cpp
	@rm -f cfg[0-9].i cfg[0-9][0-9].i

common:
	./mkcfgs.pl
	$(MAKE) -f Makefile.auto

verbose:	common
	@rm -f cfg*.cpp cfg*.o

compile:	common

=== translations/utilities/Makefile ===
# -*- Mode: Makefile; tab-width: 4 -*-
# Copyright (C) 2003-2011 Opera Software ASA.  All rights reserved.
#
# Build the lngtest utility for Linux x86/amd64 and Windows.
# Build the ZIP file for distribution in the translations SVN repository
# (the Mac OS command-line binary must be built separately and placed
#  into zipdir/macos/ first to create a complete archive).
#
# Tested on Linux amd64. May work for other configurations as well.
# The Debian package mingw32 allows Windows cross-compilation on Linux.
#
all: binaries strip

BIN=lngtest.i386 lngtest.amd64 lngtest.exe

binaries: $(BIN)

lngtest.i386: lngtest.c
	gcc -Wall -g -m32 -o lngtest.i386 lngtest.c

lngtest.amd64: lngtest.c
	gcc -Wall -g -m64 -o lngtest.amd64 lngtest.c

lngtest.exe: lngtest.c
	i586-mingw32msvc-gcc -Wall -o lngtest.exe lngtest.c

strip: $(BIN)
	strip $(BIN)

clean:
	-rm $(BIN)
	-rm -rf zipdir

zip: strip
	-mkdir -p zipdir/linux.amd64 zipdir/linux.i386 zipdir/windows zipdir/macos zipdir/src/lngtest.xcodeproj
	cp lngtest.amd64 zipdir/linux.amd64/lngtest
	cp lngtest.i386 zipdir/linux.i386/lngtest
	cp lngtest.exe zipdir/windows/
	cp Makefile lngtest.c lngtest.dsp lngtest.dsw zipdir/src/
	cp lngtest.xcodeproj/project.pbxproj zipdir/src/lngtest.xcodeproj/
	test -x zipdir/macos/lngtest || echo 'Mac binary missing, and cannot build' >&2
	cd zipdir ; zip -r /tmp/lngtest-`date +"%Y%m%d"` src macos linux.amd64 linux.i386 windows

.PHONY: binaries strip clean zip

=== unicode/documentation/Makefile ===
all: wordbreak.svg sentencebreak.svg

%.svg: %.dot
	dot -o $@ -Tsvg $<

=== unicode/scripts/Makefile ===
UNICODEDATA=../data/UnicodeData.txt
CASEFOLD=../data/CaseFolding.txt
BLOCKS=../data/Blocks.txt
JOINING=../data/ArabicShaping.txt
PROPLIST=../data/PropList.txt
LINEBREAK=../data/LineBreak.txt
MIRROR=../data/BidiMirroring.txt
WORDBREAK=../data/WordBreakProperty.txt
SENTENCEBREAK=../data/SentenceBreakProperty.txt
COMPEXCLUSIONS=../data/CompositionExclusions.txt
SCRIPTS=../data/Scripts.txt
DERIVEDJOINING=../data/DerivedJoiningType.txt
NAMESLIST=../data/NamesList.txt
THAIWRAP=../data/thai-wrap.js
HEADER=../unicode.h
PIKE ?= pike -DUNICODE_BUILD_TABLES
PYTHON ?= python
PERL ?= perl

SELFTEST=cls.dat bidi.dat lbt2.dat mirror.dat lower.dat upper.dat wbt.dat sbt.dat comb.dat \
	blocks.dat script.dat scasefolding.dat fcasefolding.dat joiningtype.dat \
	proplist.dat
RUNTIME=../tables/bidiclass.inl ../tables/canonicals.inl ../tables/caseinfo.inl \
	../tables/charclass.inl ../tables/decompositions.inl ../tables/linebreak.inl \
	../tables/mirror.inl ../tables/wordbreak.inl ../tables/sentencebreak.inl \
	../tables/scripts.inl ../tables/casefold.inl ../tables/blocks.inl \
	../tables/joiningtype.inl ../tables/proplist.inl \
	../tables/unicode_linebreak_thai_fallback.inl ../../display/text_shaper.inl

all: $(SELFTEST) $(RUNTIME)

make_x=$(PIKE) ../scripts/$(1) < $(2) > "$(3)" || { rm "$(3)"; exit 1; }
make_py=$(PYTHON) ../scripts/$(1) < $(2) > "$(3)" || { rm "$(3)"; exit 1; }

../tables/decompositions.inl: ../scripts/make_decompose.pike $(UNICODEDATA) $(HEADER) $(COMPEXCLUSIONS)
	 $(call make_x,../scripts/make_decompose.pike,$(UNICODEDATA),../tables/decompositions.inl)

bidi.dat ../tables/bidiclass.inl: ../scripts/make_bidi.pike $(UNICODEDATA) $(HEADER)
	 $(call make_x,../scripts/make_bidi.pike,$(UNICODEDATA),../tables/bidiclass.inl)

mirror.dat ../tables/mirror.inl: ../scripts/make_mirror.pike $(MIRROR) $(HEADER)
	 $(call make_x,../scripts/make_mirror.pike,$(MIRROR),../tables/mirror.inl)

lbt2.dat ../tables/linebreak.inl: ../scripts/make_linebreak.pike $(LINEBREAK) $(HEADER)
	 $(call make_x,../scripts/make_linebreak.pike,$(LINEBREAK),../tables/linebreak.inl)

cls.dat ../tables/charclass.inl: ../scripts/make_charclass.pike $(UNICODEDATA) $(HEADER)
	 $(call make_x,../scripts/make_charclass.pike,$(UNICODEDATA),../tables/charclass.inl)

comb.dat ../tables/canonicals.inl: ../scripts/make_canonicals.pike $(UNICODEDATA) $(HEADER)
	 $(call make_x,../scripts/make_canonicals.pike,$(UNICODEDATA),../tables/canonicals.inl)

lower.dat upper.dat ../tables/caseinfo.inl: ../scripts/make_caseinfo.pike $(UNICODEDATA) $(HEADER)
	 $(call make_x,../scripts/make_caseinfo.pike,$(UNICODEDATA),../tables/caseinfo.inl)

wbt.dat ../tables/wordbreak.inl: ../scripts/make_wordbreak.pike $(WORDBREAK) $(HEADER)
	 $(call make_x,../scripts/make_wordbreak.pike,$(WORDBREAK),../tables/wordbreak.inl)

sbt.dat ../tables/sentencebreak.inl: ../scripts/make_sentencebreak.pike $(SENTENCEBREAK) $(HEADER)
	 $(call make_x,../scripts/make_sentencebreak.pike,$(SENTENCEBREAK),../tables/sentencebreak.inl)

script.dat ../tables/scripts.inl: ../scripts/make_scripts.py $(SCRIPTS) $(HEADER)
	 $(call make_py,../scripts/make_scripts.py,$(SCRIPTS),../tables/scripts.inl)

scasefolding.dat fcasefolding.dat ../tables/casefold.inl: ../scripts/make_casefold.py $(CASEFOLD) $(HEADER)
	 $(call make_py,../scripts/make_casefold.py,$(CASEFOLD),../tables/casefold.inl)

blocks.dat ../tables/blocks.inl: ../scripts/make_blocks.py $(BLOCKS) $(HEADER)
	 $(call make_py,../scripts/make_blocks.py,$(BLOCKS),../tables/blocks.inl)

joiningtype.dat ../tables/joiningtype.inl: ../scripts/make_joiningtype.py $(JOINING) $(HEADER)
	 $(call make_py,../scripts/make_joiningtype.py,$(JOINING),../tables/joiningtype.inl)

proplist.dat ../tables/proplist.inl: ../scripts/make_proplist.py $(PROPLIST) $(HEADER)
	 $(call make_py,../scripts/make_proplist.py,$(PROPLIST),../tables/proplist.inl)

../tables/unicode_linebreak_thai_fallback.inl: ../scripts/make_unicode_linebreak_thai_fallback_data.py $(THAIWRAP)
	$(PYTHON) ../scripts/make_unicode_linebreak_thai_fallback_data.py --input $(THAIWRAP) --output ../tables/unicode_linebreak_thai_fallback.inl

../../display/text_shaper.inl: ../../display/scripts/shaping.pl $(DERIVEDJOINING) $(NAMESLIST)
	cd ../../display/scripts && $(RUNPERL) ./shaping.pl

clean:
	-rm $(SELFTEST) $(RUNTIME)

=== webgl/standalone/Makefile ===
#
# Makefile for building 'webgl' standalone.
# Setup shamelessly stolen from Carakan :)
#
all: wgl

INCLUDE=
CCFLAGS=

ifneq ($(NOUSERMK), YES)
-include user.mk
endif

Cc=$(CROSS)gcc$(COMPILER_SUFFIX)
CC=$(CROSS)g++$(COMPILER_SUFFIX)

ROOT = ../../..

SRC=\
    modules/unicode/unicode_bidi.cpp \
    modules/unicode/unicode_bidiutils.cpp \
    modules/unicode/unicode_case.cpp \
    modules/unicode/unicode_linebreak.cpp \
    modules/unicode/unicode_module.cpp \
    modules/unicode/unicode_normalize.cpp \
    modules/unicode/unicode_properties.cpp \
    modules/unicode/unicode_segmenter.cpp \
    modules/webgl/src/wgl_ast.cpp \
    modules/webgl/src/wgl_builder.cpp \
    modules/webgl/src/wgl_cgbuilder.cpp \
    modules/webgl/src/wgl_context.cpp \
    modules/webgl/src/wgl_error.cpp \
    modules/webgl/src/wgl_lexer.cpp \
    modules/webgl/src/wgl_parser.cpp \
    modules/webgl/src/wgl_pretty_printer.cpp \
    modules/webgl/src/wgl_printer.cpp \
    modules/webgl/src/wgl_printer_console.cpp \
    modules/webgl/src/wgl_printer_stdio.cpp \
    modules/webgl/src/wgl_string.cpp \
    modules/webgl/src/wgl_symbol.cpp \
    modules/webgl/src/wgl_validate.cpp \
    modules/webgl/src/wgl_validator.cpp \
    modules/webgl/src/wgl_visit.cpp \
    modules/webgl/src/wgl_intrinsics.cpp \
    modules/memory/src/memory_fundamentals.cpp \
    modules/memory/src/memory_segment.cpp \
    modules/memory/src/memory_pooling.cpp \
    modules/memory/src/memory_debug.cpp \
    modules/memory/src/memory_memguard.cpp \
    modules/memory/src/memory_virtualalloc.cpp \
    modules/memory/src/memory_smo.cpp \
    modules/memory/src/memory_module.cpp \
    modules/memory/src/memory_opsrcsite.cpp \
    modules/memory/src/memory_opallocinfo.cpp \
    modules/memory/src/memory_events.cpp \
    modules/memory/src/memory_reporting.cpp \
    modules/memory/src/memory_upperten.cpp \
    modules/memory/src/memory_state.cpp \
    modules/memory/src/memory_group.cpp \
    modules/memory/src/memory_executable.cpp \
    modules/stdlib/util/opbitvector.cpp \
    modules/stdlib/util/opdate.cpp \
    modules/stdlib/src/stdlib_array.cpp \
    modules/stdlib/src/stdlib_date.cpp \
    modules/stdlib/src/stdlib_float.cpp \
    modules/stdlib/src/stdlib_integer.cpp \
    modules/stdlib/src/stdlib_memory.cpp \
    modules/stdlib/src/stdlib_module.cpp \
    modules/stdlib/src/stdlib_printf.cpp \
    modules/stdlib/src/stdlib_string.cpp \
    modules/stdlib/src/stdlib_strtod.cpp \
    modules/stdlib/src/stdlib_unicode.cpp \
    modules/stdlib/src/thirdparty_dtoa_floitsch/stdlib_dtoa_floitsch.cpp \
    modules/stdlib/src/stdlib_double_format.cpp \
    modules/stdlib/src/thirdparty_printf/uni_printf.cpp \
    modules/stdlib/src/thirdparty_printf/uni_scanf.cpp \
    modules/stdlib/src/thirdparty_rng/stdlib_mt19937ar.cpp

SRC_STANDALONE=\
    ./modules/util/adt/bytebuffer.cpp \
    ./modules/util/adt/opvector.cpp \
    ./modules/util/excepts.cpp \
    ./modules/util/md5.c \
    ./modules/util/operalib.cpp \
    ./modules/util/tempbuf.cpp \
    ./modules/util/uniprntf.cpp \
    ./modules/util/OpHashTable.cpp \
    ./modules/util/opstring.cpp \
    ./modules/util/simset.cpp \
    ./modules/pi/system/OpMemory.cpp

OBJ_CPP=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(filter %.cpp,$(SRC)))
OBJ_C=$(patsubst %.c,obj/$(OUTPUT)/%.o,$(filter %.c,$(SRC)))
OBJ_STANDALONE_CPP=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(filter %.cpp,$(SRC_STANDALONE)))
OBJ_STANDALONE_C=$(patsubst %.c,obj/$(OUTPUT)/%.o,$(filter %.c,$(SRC_STANDALONE)))

OBJ=$(OBJ_CPP) $(OBJ_C)
OBJ_STANDALONE=$(OBJ_STANDALONE_CPP) $(OBJ_STANDALONE_C)

INCLUDE += -I. -I$(ROOT)

ifeq (NO$(filter CYG%, $(shell uname -s)), NO)
CCFLAGS += -DUNIX -DLINGOGI
else
CCFLAGS += -DMSWIN
endif
CCFLAGS += -DWGL_STANDALONE -DCANVAS3D_SUPPORT
CCFLAGS += -DWCHAR_IS_UNICHAR -fshort-wchar -MMD -fno-exceptions
CCFLAGS += $(INCLUDE)
CCFLAGS += $(CCFLAGS_USER)
CCFLAGS += -Wall -Wno-parentheses -Wno-switch

CCFLAGS_DEBUG = -D_DEBUG -DDEBUG_ENABLE_OPASSERT -ggdb
CCFLAGS_RELEASE = -O2 -ggdb

MODE ?= DEBUG

ifeq ($(MODE), DEBUG)
CCFLAGS += $(CCFLAGS_DEBUG)
OUTPUT ?= debug
else
CCFLAGS += $(CCFLAGS_RELEASE)
OUTPUT ?= release
EXEPREFIX ?= fast-
endif

wgl : wgl.cpp $(OBJ) $(OBJ_STANDALONE)
	$(CC) $(CCFLAGS) -o $@ $^

debug:
	@echo $(OBJ)

$(OBJ_CPP): obj/$(OUTPUT)/%.o: $(ROOT)/%.cpp
	@mkdir -p $(dir $@)
	@echo Compiling $(patsubst obj/$(OUTPUT)/%,%,$@)
	@$(CC) $(CCFLAGS) $(INCLUDE) -fpermissive -c $< -o $@

$(OBJ_C): obj/$(OUTPUT)/%.o: $(ROOT)/%.c
	@mkdir -p $(dir $@)
	@echo Compiling $(patsubst obj/$(OUTPUT)/%,%,$@)
	@$(Cc) $(CCFLAGS) $(INCLUDE) -c $< -o $@

$(OBJ_STANDALONE_CPP): obj/$(OUTPUT)/%.o: %.cpp
	@mkdir -p $(dir $@)
	@echo Compiling $(patsubst obj/$(OUTPUT)/%,%,$@)
	@$(CC) $(CCFLAGS) $(INCLUDE) -fpermissive -c $< -o $@

$(OBJ_STANDALONE_C): obj/$(OUTPUT)/%.o: %.c
	@mkdir -p $(dir $@)
	@echo Compiling $(patsubst obj/$(OUTPUT)/%,%,$@)
	@$(Cc) $(CCFLAGS) $(INCLUDE) -c $< -o $@

$(patsubst %.o,%.d,$(OBJ_CPP)): obj/$(OUTPUT)/%.d: %.cpp
	@rm -f $@

$(patsubst %.o,%.d,$(OBJ_C)): obj/$(OUTPUT)/%.d: %.c
	@rm -f $@

$(patsubst %.o,%.d,$(OBJ_STANDALONE_CPP)): obj/$(OUTPUT)/%.d: %.cpp
	@rm -f $@

$(patsubst %.o,%.d,$(OBJ_STANDALONE_C)): obj/$(OUTPUT)/%.d: %.c
	@rm -f $@

clean:
	rm -rf obj

tags:
	rm -f TAGS
	find .. -name '*.h'	-print0 | xargs -0 etags -a --language=c++
	find .. -name '*.cpp'	-print0 | xargs -0 etags -a --language=c++
	find .. -name '*.c'	-print0 | xargs -0 etags -a --language=c

# Not all object files depend on all generated header files, really, but in
# practice it doesn't matter much, and it's nice if the generation happens
# before the actually dependent object files are compiled.
$(OBJECTS): Makefile $(GENERATED_HEADERS)

$(JSSHELL_OBJS): Makefile $(GENERATED_HEADERS)
$(TESTLEXER_OBJS): Makefile $(GENERATED_HEADERS)
$(OPPSEUDOTHREAD_OBJS): Makefile $(GENERATED_HEADERS)

-include $(OBJ:%.o=%.d)
-include $(OBJ_STANDALONE:%.o=%.d)

=== webgl/tests/Makefile ===
all: tests

tests:
	./wgl-test.sh

=== ecmascript/carakan/standalone/Makefile ===
all: buildjsshell

INCLUDE=
CCFLAGS=

ifneq ($(NOUSERMK), YES)
-include user.mk
endif

Cc=$(CROSS)gcc$(COMPILER_SUFFIX)
CC=$(CROSS)g++$(COMPILER_SUFFIX)

REGRESSION = regression

ROOT = ../../../..

SRC=\
    modules/ecmascript/carakan/src/vm/es_engine.cpp \
    modules/unicode/unicode_bidi.cpp \
    modules/unicode/unicode_bidiutils.cpp \
    modules/unicode/unicode_case.cpp \
    modules/unicode/unicode_module.cpp \
    modules/unicode/unicode_normalize.cpp \
    modules/unicode/unicode_properties.cpp \
    modules/unicode/unicode_segmenter.cpp \
    modules/stdlib/util/opbitvector.cpp \
    modules/stdlib/util/opdate.cpp \
    modules/stdlib/src/stdlib_array.cpp \
    modules/stdlib/src/stdlib_date.cpp \
    modules/stdlib/src/stdlib_float.cpp \
    modules/stdlib/src/stdlib_integer.cpp \
    modules/stdlib/src/stdlib_memory.cpp \
    modules/stdlib/src/stdlib_module.cpp \
    modules/stdlib/src/stdlib_printf.cpp \
    modules/stdlib/src/stdlib_string.cpp \
    modules/stdlib/src/stdlib_strtod.cpp \
    modules/stdlib/src/stdlib_unicode.cpp \
    modules/stdlib/src/stdlib_double_format.cpp \
    modules/stdlib/src/thirdparty_printf/uni_printf.cpp \
    modules/stdlib/src/thirdparty_printf/uni_scanf.cpp \
    modules/stdlib/src/thirdparty_rng/stdlib_mt19937ar.cpp \
    modules/stdlib/src/thirdparty_dtoa_floitsch/stdlib_dtoa_floitsch.cpp \
    modules/regexp/src/regexp_advanced_api.cpp \
    modules/regexp/src/regexp_api.cpp \
    modules/regexp/src/regexp_engine.cpp \
    modules/regexp/src/re_class.cpp \
    modules/regexp/src/re_compiler.cpp \
    modules/regexp/src/re_matcher.cpp \
    modules/regexp/src/re_object.cpp \
    modules/regexp/src/re_searcher.cpp \
    modules/regexp/src/re_native.cpp \
    modules/regexp/src/re_native_ia32.cpp \
    modules/regexp/src/re_native_arm.cpp \
    modules/regexp/src/re_native_mips.cpp \
    modules/ecmascript/carakan/src/util/es_native_disass.c \
    modules/memory/src/memory_fundamentals.cpp \
    modules/memory/src/memory_segment.cpp \
    modules/memory/src/memory_pooling.cpp \
    modules/memory/src/memory_debug.cpp \
    modules/memory/src/memory_memguard.cpp \
    modules/memory/src/memory_virtualalloc.cpp \
    modules/memory/src/memory_smo.cpp \
    modules/memory/src/memory_module.cpp \
    modules/memory/src/memory_opsrcsite.cpp \
    modules/memory/src/memory_opallocinfo.cpp \
    modules/memory/src/memory_events.cpp \
    modules/memory/src/memory_reporting.cpp \
    modules/memory/src/memory_upperten.cpp \
    modules/memory/src/memory_state.cpp \
    modules/memory/src/memory_group.cpp \
    modules/memory/src/memory_executable.cpp \
    modules/ecmascript/carakan/src/builtins/es_array_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_boolean_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_date_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_debug_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_error_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_function_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_global_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_json_export.cpp \
    modules/ecmascript/carakan/src/builtins/es_json_import.cpp \
    modules/ecmascript/carakan/src/builtins/es_math_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_number_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_object_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_regexp_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_string_builtins.cpp \
    modules/ecmascript/carakan/src/builtins/es_typedarray_builtins.cpp \
    modules/ecmascript/carakan/src/compiler/es_analyzer.cpp \
    modules/ecmascript/carakan/src/compiler/es_compiler.cpp \
    modules/ecmascript/carakan/src/compiler/es_compiler_expr.cpp \
    modules/ecmascript/carakan/src/compiler/es_compiler_stmt.cpp \
    modules/ecmascript/carakan/src/compiler/es_compiler_unroll.cpp \
    modules/ecmascript/carakan/src/compiler/es_code.cpp \
    modules/ecmascript/carakan/src/compiler/es_disassembler.cpp \
    modules/ecmascript/carakan/src/compiler/es_disassemble_instr.cpp \
    modules/ecmascript/carakan/src/compiler/es_lexer.cpp \
    modules/ecmascript/carakan/src/compiler/es_native.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_codegen.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_regalloc.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_ia32.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_arm.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_mips.cpp \
    modules/ecmascript/carakan/src/compiler/es_native_stack_frame.cpp \
    modules/ecmascript/carakan/src/compiler/es_parser.cpp \
    modules/ecmascript/carakan/src/compiler/es_parser_expr.cpp \
    modules/ecmascript/carakan/src/compiler/es_parser_stmt.cpp \
    modules/ecmascript/carakan/src/compiler/es_process_instr.cpp \
    modules/ecmascript/carakan/src/compiler/es_source_location.cpp \
    modules/ecmascript/carakan/src/ecmascript_manager.cpp \
    modules/ecmascript/carakan/src/ecmascript_module.cpp \
    modules/ecmascript/carakan/src/ecmascript_object.cpp \
    modules/ecmascript/carakan/src/ecmascript_runtime.cpp \
    modules/ecmascript/carakan/src/es_program_cache.cpp \
    modules/ecmascript/carakan/src/kernel/es_string.cpp \
    modules/ecmascript/carakan/src/kernel/es_collector.cpp \
    modules/ecmascript/carakan/src/kernel/es_mark_sweep_heap.cpp \
    modules/ecmascript/carakan/src/kernel/es_page.cpp \
    modules/ecmascript/carakan/src/kernel/es_rts.cpp \
    modules/ecmascript/carakan/src/kernel/es_value.cpp \
    modules/ecmascript/carakan/src/kernel/es_box.cpp \
    modules/ecmascript/carakan/src/util/es_hash_table.cpp \
    modules/ecmascript/carakan/src/util/es_formatter.cpp \
    modules/ecmascript/carakan/src/object/es_class.cpp \
    modules/ecmascript/carakan/src/object/es_clone_object.cpp \
    modules/ecmascript/carakan/src/object/es_arguments.cpp \
    modules/ecmascript/carakan/src/object/es_array_object.cpp \
    modules/ecmascript/carakan/src/object/es_boolean_object.cpp \
    modules/ecmascript/carakan/src/object/es_date_object.cpp \
    modules/ecmascript/carakan/src/object/es_error_object.cpp \
    modules/ecmascript/carakan/src/object/es_number_object.cpp \
    modules/ecmascript/carakan/src/object/es_regexp_object.cpp \
    modules/ecmascript/carakan/src/object/es_string_object.cpp \
    modules/ecmascript/carakan/src/object/es_typedarray.cpp \
    modules/ecmascript/carakan/src/object/es_object.cpp \
    modules/ecmascript/carakan/src/object/es_host_object.cpp \
    modules/ecmascript/carakan/src/object/es_property.cpp \
    modules/ecmascript/carakan/src/object/es_property_table.cpp \
    modules/ecmascript/carakan/src/object/es_function.cpp \
    modules/ecmascript/carakan/src/object/es_global_object.cpp \
    modules/ecmascript/carakan/src/object/es_indexed.cpp \
    modules/ecmascript/carakan/src/object/es_special_property.cpp \
    modules/ecmascript/carakan/src/util/es_bcdebugger.cpp \
    modules/ecmascript/carakan/src/util/es_bclogger.cpp \
    modules/ecmascript/carakan/src/util/es_codegenerator_arm.cpp \
    modules/ecmascript/carakan/src/util/es_codegenerator_ia32.cpp \
    modules/ecmascript/carakan/src/util/es_codegenerator_mips.cpp \
    modules/ecmascript/carakan/src/util/es_strtod.cpp \
    modules/ecmascript/carakan/src/util/es_util.cpp \
    modules/ecmascript/carakan/src/util/es_tempbuf.cpp \
    modules/ecmascript/carakan/src/vm/es_allocation_context.cpp \
    modules/ecmascript/carakan/src/vm/es_context.cpp \
    modules/ecmascript/carakan/src/vm/es_execution_context.cpp \
    modules/ecmascript/carakan/src/vm/es_frame.cpp \
    modules/ecmascript/carakan/src/vm/es_instructionhandlers.cpp \
    modules/ecmascript/carakan/src/vm/es_register_blocks.cpp \
    modules/ecmascript/carakan/src/vm/es_suspended_call.cpp \
    modules/ecmascript/oppseudothread/oppseudothread.cpp \
    modules/ecmascript/oppseudothread/oppseudothread_threaded.cpp \
    modules/ecmascript/oppseudothread/oppseudothread_pthreads.cpp \
    modules/ecmascript/structured/es_persistent.cpp

SRC_CPP=$(filter %.cpp,$(SRC))
SRC_C=$(filter %.c,$(SRC))

SRC_STANDALONE=\
    modules/util/adt/bytebuffer.cpp \
    modules/util/adt/opvector.cpp \
    modules/util/excepts.cpp \
    modules/util/operalib.cpp \
    modules/util/tempbuf.cpp \
    modules/util/uniprntf.cpp \
    modules/util/OpHashTable.cpp \
    modules/util/opstring.cpp \
    modules/util/simset.cpp \
    modules/pi/system/OpMemory.cpp

SRC_JSSHELL=\
    programs/stopwatch.cpp \
    programs/jsshell_object.cpp \
    programs/jsshell.cpp

ifeq ($(JUMBO), YES)
OBJ_JUMBO_CPP=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(shell python jumbo.py $(SRC_CPP)))
else
OBJ_CPP=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(SRC_CPP))
endif

OBJ_C=$(patsubst %.c,obj/$(OUTPUT)/%.o,$(SRC_C))
OBJ_STANDALONE_CPP=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(filter %.cpp,$(SRC_STANDALONE)))
OBJ_STANDALONE_C=$(patsubst %.c,obj/$(OUTPUT)/%.o,$(filter %.c,$(SRC_STANDALONE)))
OBJ_JSSHELL=$(patsubst %.cpp,obj/$(OUTPUT)/%.o,$(filter %.cpp,$(SRC_JSSHELL)))

OBJ=$(OBJ_CPP) $(OBJ_JUMBO_CPP) $(OBJ_C)
OBJ_STANDALONE=$(OBJ_STANDALONE_CPP) $(OBJ_STANDALONE_C)

INCLUDE += -Iobj/$(OUTPUT)/include -I. -I$(ROOT)

ifeq ($(shell uname -m), ppc)
ARCHITECTURE=POWERPC
DISABLE_NATIVE_SUPPORT=YES
endif

CCFLAGS += -DUNIX -DLINGOGI -DWCHAR_IS_UNICHAR -fshort-wchar -DECMASCRIPT_STANDALONE_COMPILER -MMD -fno-exceptions
CCFLAGS_CPP += -fno-rtti

ES_STANDALONE_VERSION:=$(shell git describe)
ES_STANDALONE_BUILDTIME:=$(shell date)

CCFLAGS += -DES_STANDALONE_VERSION='"$(ES_STANDALONE_VERSION)"' -DES_STANDALONE_BUILDTIME='"$(ES_STANDALONE_BUILDTIME)"'

ifneq ($(DISABLE_NATIVE_SUPPORT), YES)
CCFLAGS += -DES_NATIVE_SUPPORT -DECMASCRIPT_NATIVE_SUPPORT -DEXECUTABLE_MEMORY_MANAGER -DMEMORY_EXEC_SEGMENT_SIZE=32768
endif
ifneq ($(DISABLE_DISASSEMBLER), YES)
CCFLAGS += -DES_DISASSEMBLER_SUPPORT
endif
CCFLAGS += -DES_COMBINED_ADD_SUPPORT
CCFLAGS += -DES_CARAKAN_PARM_MAX_PARSER_STACK=900*1024
ifeq ($(STANDALONE_ES_DEBUGGER_SUPPORT), YES)
CCFLAGS += -DECMASCRIPT_DEBUGGER
endif
CCFLAGS += $(CCFLAGS_USER)
CCFLAGS += -Wall -Wno-parentheses -Wno-switch

CCFLAGS_DEBUG = -D_DEBUG -DDEBUG_ENABLE_OPASSERT -ggdb -DES_HARDCORE_GC_MODE -DES_BYTECODE_LOGGER -DES_DEBUG_COMPACT_OBJECTS
CCFLAGS_RELEASE = -O2 -ggdb -DNDEBUG

ifeq ($(STRICT_WARNINGS), YES)
CCFLAGS_OBJ += -Werror
endif

ARCHITECTURE ?= auto

ifeq ($(ARCHITECTURE), ARM)
CCFLAGS += -DARCHITECTURE_ARM -DARCHITECTURE_ARM_VFP -Wno-psabi
ARCHITECTURE_NAME = arm
endif

ifeq ($(ARCHITECTURE), THUMB)
CCFLAGS += -DARCHITECTURE_THUMB -mthumb
ARCHITECTURE_NAME = thumb
endif

ifeq ($(ARCHITECTURE), SUPERH)
CCFLAGS += -DARCHITECTURE_SUPERH
ARCHITECTURE_NAME = superh
endif

ifeq ($(ARCHITECTURE), MIPS)
CCFLAGS += -DARCHITECTURE_MIPS
ARCHITECTURE_NAME = mips
endif

ifeq ($(ARCHITECTURE), POWERPC)
CCFLAGS += -DARCHITECTURE_POWERPC -DIEEE_MC68k
ARCHITECTURE_NAME = powerpc
endif

ifneq (, $(findstring $(ARCHITECTURE), IA32 AMD64 auto))
ARCHITECTURE_NAME = ia32
CCFLAGS += -DARCHITECTURE_IA32 -DARCHITECTURE_SSE

ifeq ($(shell uname -m), x86_64)
AUTO_ARCHITECTURE = AMD64
else
AUTO_ARCHITECTURE = IA32
endif

ifeq ($(ARCHITECTURE), auto)
ARCHITECTURE = $(AUTO_ARCHITECTURE)
endif

ifeq ($(ARCHITECTURE), IA32)
ifneq ($(AUTO_ARCHITECTURE), IA32)
CCFLAGS_ARCH = -m32
endif
endif

ifeq ($(ARCHITECTURE), AMD64)
CCFLAGS_ARCH = -DSIXTY_FOUR_BIT -DARCHITECTURE_AMD64 -DARCHITECTURE_AMD64_UNIX
endif
endif

ifeq ($(shell uname -s), Darwin)
ifeq ($(ARCHITECTURE), IA32)
CCFLAGS += -DES_GCC_STACK_REALIGNMENT
endif
endif

ifeq ($(NATIVE_DISASS), YES)
CCFLAGS += -DNATIVE_DISASSEMBLER_SUPPORT
LIBRARIES += -lopcodes -lbfd -liberty
endif

ifeq ($(THREADED), YES)
CCFLAGS += -DOPPSEUDOTHREAD_THREADED
LIBRARIES += -lpthread
endif

ifeq ($(COPY_COLLECTOR), YES)
CCFLAGS += -DES_COPY_COLLECTOR
endif

MODE ?= DEBUG

=== encodings/testsuite/charconv/Makefile ===
# -*- Mode: Makefile; tab-width: 4 -*-
# Copyright (C) 2011-2012 Opera Software ASA.  All rights reserved.
#
# This file is part of the Opera web browser.  It may not be distributed
# under any circumstances.
#
# Build the external encodings regression tests.
# Tested on Linux amd64. May work for other configurations as well.
#
CFLAGS=-g -fshort-wchar -Iinternal -I../../ -I../../../../ -DENCODINGS_REGTEST -DUNICODE -DUNICODE_UTF16
CXXFLAGS=$(CFLAGS)
CXX=g++

OBJS=big5-decoder.o big5hkscs-decoder.o dbcs-decoder.o euc-jp-decoder.o euc-kr-decoder.o \
	euc-tw-decoder.o gbk-decoder.o hz-decoder.o identityconverter.o inputconverter.o \
	iso-2022-cn-decoder.o iso-2022-jp-decoder.o iso-8859-1-decoder.o jis-decoder.o \
	sbcs-decoder.o sjis-decoder.o utf16-decoder.o utf7-decoder.o \
	utf8-decoder.o \
	big5hkscs-encoder.o dbcs-encoder.o encoder-utility.o euc-tw-encoder.o \
	gb18030-encoder.o hz-encoder.o iso-2022-cn-encoder.o iso-8859-1-encoder.o \
	jis-encoder.o outputconverter.o sbcs-encoder.o utf16-encoder.o \
	utf7-encoder.o utf8-encoder.o \
	filetablemanager.o reverse_table_builder.o romtablemanager.o \
	tablemanager.o \
	charconv.o chartest.o fake_opfile.o utility.o \
	charsetnames.o \
	utf8.o encodingbin.o

HEADERS=internal/core/pch.h ../../charconverter.h
DECODERS_HEADERS=$(wildcard ../../decoders/*.h)
ENCODERS_HEADERS=$(wildcard ../../encoders/*.h)
TABLEMAN_HEADERS=$(wildcard ../../tablemanager/*.h)
UTILITY__HEADERS=$(wildcard ../../utility/*.h)
CHARCONV_HEADERS=$(wildcard *.h)

BIN=charconv

all: $(BIN) encoding.bin

clean:
	-rm $(OBJS) $(BIN) encoding.bin

%.o: ../../decoders/%.cpp $(HEADERS) $(DECODERS_HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

%.o: ../../encoders/%.cpp $(HEADERS) $(ENCODERS_HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

%.o: ../../tablemanager/%.cpp $(HEADERS) $(TABLEMAN_HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

%.o: ../../utility/%.cpp $(HEADERS) $(UTILITY__HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

%.o: %.cpp $(HEADERS) $(CHARCONV_HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

utf8.o: ../../../../modules/unicode/utf8.cpp $(HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

encodingbin.o: ../../../../platforms/core/encodingbin.cpp $(HEADERS)
	$(CXX) -c $(CXXFLAGS) $< -o $@

$(BIN): $(OBJS)
	$(CXX) $(OBJS) -o $(BIN)

encoding.bin: ../../../../opera/encoding.bin
	ln -s ../../../../opera/encoding.bin .

.PHONY: clean all

=== paxage/debian/control ===
Package: @@{CONF:product}
Version: @@{CONF:version}.@@{CONF:build}
Section: non-free/web
Priority: optional
Architecture: @@{TRADITIONAL_ARCH}
Depends: @@{FILES:shlibdeps}, gstreamer0.10-plugins-good, debconf (>= 0.5) | debconf-2.0, fonts-liberation | ttf-liberation | ttf-mscorefonts-installer
Recommends: flashplugin-nonfree, cups-client
Provides: www-browser, mail-reader, imap-client, news-reader
Installed-Size: @@{FILES:installedsize}
Maintainer: @@{S_MAINTAINER}
Bugs: @@{S_BUGREPORT_URL}
Homepage: @@{S_HOMEPAGE}
Description: @@{S_ONELINE_DESC}
 @@include ../doc/description.inc
